# TODO
# - pick items from PLD-doc/RPM-loops.txt
Summary:	PLD Linux RPM macros dealing with loop errors
Summary(pl.UTF-8):	Makra RPM-a do rozwiązywania zapętlonych zależności w PLD Linuksie
Name:		rpm-whiteout
Version:	1.41
Release:	3
License:	GPL
Group:		Base
Requires:	rpm-base
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PLD Linux RPM macros dealing with loop errors in RPM packages in PLD
Linux Distribution that can't solved easily or not wanted to be
solved.

%description -l pl.UTF-8
Makra RPM-a do rozwiązywania w pakietach RPM dystrybucji PLD Linux
zapętlonych zależności, których nie można inaczej rozwiązać w łatwy
sposób.

%prep
%setup -qcT

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/rpm
cat <<'EOF' > $RPM_BUILD_ROOT/etc/rpm/macros.whiteout
#	Relations between package names that cause dependency loops
#	with legacy packages that cannot be fixed. Relations are
#	specified as
#		p>q
#	where package p has a Requires: on something that package q Provides:
#	so p is installed before q normally.
#
# Note: that there cannot be any whitespace within the string "p>q",
#	and that both p and q are package names (i.e. no version/release).

# Note: these are PACKAGE names, not Provide names.

 %%_dependency_whiteout	\
	%%{_dependency_whiteouts_subpkg}	\
	fontpostinst>t1lib \
	glibc>nss-softokn-freebl \
	glibc>tzdata \
	gmplayer>mplayer-skin-KDE \
	kdebase-desktop>kde-kside-PLD \
	kdebase-desktop>kde-logoutpic-PLD \
	kdebase-desktop>kde-splash-Default \
	kdelibs>kdelibs-shared \
	koffice-kexi>koffice-kspread \
	konqueror>kdeaddons-fsview \
	konqueror>kdeaddons-konqueror \
	konqueror>kdemultimedia-audiocd \
	php-pear-PEAR-core>php-pear-Console_Getopt \
	rc-scripts>blockdev \
	upstart>dbus \
	vim-rt>vim-plugin-securemodelines \
	vim-rt>vim-syntax-poldek \
	vim-rt>vim-syntax-spec \
 %%{nil}

# dependency whiteouts if main pkg requires it's subpkg, this should be handed
# somehow in rpm itself, but for now keep the list.
 %%_dependency_whiteouts_subpkg	\
	QtGui>Qt3Support \
	QtGui>QtSvg \
	ZendFramework-Zend_Cache>ZendFramework-Zend_Json \
	ZendFramework-Zend_Cache>ZendFramework-Zend_Log \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Dojo \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Json \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Layout \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Session \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Uri \
	ZendFramework-Zend_Controller>ZendFramework-Zend_View \
	ZendFramework-Zend_Layout>ZendFramework-Zend_View \
	ZendFramework-Zend_Validate>ZendFramework-Zend_Uri \
	ZendFramework>ZendFramework-Zend_Date \
	ZendFramework>ZendFramework-Zend_Exception \
	ZendFramework>ZendFramework-Zend_Http \
	ZendFramework>ZendFramework-Zend_Loader \
	ZendFramework>ZendFramework-Zend_Loader \
	ZendFramework>ZendFramework-Zend_Registry \
	amarok>amarok-xine \
	esound-libs>esound-alsa \
	glibc64>glibc-misc \
	glibc>glibc-localedb-all \
	glibc>glibc-misc \
	glibc>localedb-src \
	gtk+2>gtk+2-cups \
	hal>hal-info \
	java-sun-jre>java-sun-jre-X11 \
	java-sun-jre>java-sun-tools \
	lighttpd>lighttpd-mod_dirlisting \
	lighttpd>lighttpd-mod_indexfile \
	lighttpd>lighttpd-mod_staticfile \
	openjdk-jre>openjdk-tools \
	phorum>phorum-db-mysql \
	phorum>phorum-db-mysqli \
	phorum>phorum-db-sql_pool \
	php-common>php-pcre \
	php-common>php-session \
	php-common>php-simplexml \
	php-common>php-spl \
	php-spl>php-simplexml \
	php52-common>php52-pcre \
	php52-common>php52-session \
	php52-common>php52-simplexml \
	php52-common>php52-spl \
	php52-spl>php52-simplexml \
	php54-common>php54-pcre \
	php54-common>php54-session \
	php54-common>php54-simplexml \
	php54-common>php54-spl \
	php54-spl>php54-simplexml \
	roundcubemail>roundcubemail-skin-default \
	util-vserver-build>vserver-distro-pld \
	util-vserver>vserver-distro-pld \
	vim>vim-rt \
 %%{nil}
EOF

%{__sed} -i -e 's|^ %|%|g' $RPM_BUILD_ROOT/etc/rpm/macros.whiteout

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
# this file should be replaced on upgrade
%config %verify(not md5 mtime size) /etc/rpm/macros.whiteout
%changelog
* Fri May 17 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/rpm-whiteout.git;a=log;h=master

* Fri May 17 2013 Elan Ruusamäe <glen@delfi.ee> 4121022
- R: rpm-base for /etc/rpm dir

* Mon Dec 17 2012 Jan Rękorajski <baggins@pld-linux.org> 180d4b6
- rpm5 seems very anal when it comes to '%' at the start of line,
  work around this with sed
- rel 2

* Sat Aug 25 2012 Elan Ruusamäe <glen@delfi.ee> 30e38ba
- add php54 and php52 package loops

* Sat Apr 28 2012 Jan Rękorajski <baggins@pld-linux.org> 29d1ebe
- drop initramfs-tools packages, it was never properly tested, never really
  updated and their functionality is obsoleted by dracut

* Sat Oct 30 2010 Jakub Bogusz <qboosh@pld-linux.org> 840e70d
- pl

* Tue Jul 20 2010 Elan Ruusamäe <glen@pld-linux.org> 25facaf
- updated php, ZF, java-sun, glibc; added fontpostinst deps

* Tue Jul 20 2010 Elan Ruusamäe <glen@pld-linux.org> 2e80680
- fix order

* Tue Jul 20 2010 Elan Ruusamäe <glen@pld-linux.org> a1ba071
- move subpackage deps to second list

* Tue Jul 20 2010 Elan Ruusamäe <glen@pld-linux.org> f37f070
- sort lists

* Fri May 21 2010 Jacek Konieczny <jajcus@pld-linux.org> a4e5f72
- upstart>dbus

* Wed Mar 10 2010 Elan Ruusamäe <glen@pld-linux.org> 36cb33b
- phorum internal deps

* Mon Mar 08 2010 Elan Ruusamäe <glen@pld-linux.org> 6a71581
- update ZF loops

* Wed Jan 27 2010 Elan Ruusamäe <glen@pld-linux.org> da2383c
- p is installed before q (tested with lighttpd)

* Wed Jan 27 2010 Elan Ruusamäe <glen@pld-linux.org> f0cb112
- add glibc<>tzdata

* Sat Jan 02 2010 Elan Ruusamäe <glen@pld-linux.org> 94aae5c
- add openjdk whiteout

* Thu Dec 03 2009 Elan Ruusamäe <glen@pld-linux.org> 5790b3c
- simplexml requires spl

* Thu Oct 29 2009 Elan Ruusamäe <glen@pld-linux.org> 4e0b60f
- localedb-src>glibc

* Tue Jun 09 2009 Elan Ruusamäe <glen@pld-linux.org> a0503a7
- glibc-localedb-all>glibc

* Mon May 25 2009 Elan Ruusamäe <glen@pld-linux.org> 1cc164d
- glibc>nss-softokn-freebl whiteout

* Thu Mar 19 2009 Elan Ruusamäe <glen@pld-linux.org> f78bff4
- old ac loop too for vserver-distro-pld

